from random import random
import matplotlib.pyplot as plt
from scipy.special import erfinv
import numpy as np



def random_velocities(N):
    v = np.zeros((3, int(N)))
    for i in range(3):
        for n in range(int(N)):
            v[i][n] = (erfinv((random()-0.5)*2))
    return v

bins = np.linspace(0, 3, 30)
v_1 = random_velocities(1e3)
v_2 = random_velocities(1e6)

pdf_1 = np.histogram(np.sqrt(v_1[0]**2+v_1[1]**2+v_1[2]**2), bins=bins)
pdf_2 = np.histogram(np.sqrt(v_2[0]**2+v_2[1]**2+v_2[2]**2), bins=bins)
pdf1 = pdf_1[0] / sum(pdf_1[0])
pdf2 = pdf_2[0] / sum(pdf_2[0])
x1 = (pdf_1[1][1:]+pdf_1[1][:-1]) / 2
x2 = (pdf_2[1][1:]+pdf_2[1][:-1]) / 2

plt.plot(x1, pdf1, label="$10^3$ částic")
plt.plot(x2, pdf2, label="$10^6$ částic")
plt.legend()
plt.xlabel("$v \; \left[ \sqrt{2kT/m} \: \\right]$")
plt.ylabel("normed histogram")
#plt.show()
plt.savefig("du6_MB.png", dpi=150)